; 
    include \masm32\include\masm32rt.inc
; 

; 
; If you are writing code for legacy hardware, comment out the following.
; 

    .686p
    .MMX
    .XMM

; 

    include Project.inc

    .code

start:

    GLOBAL hInstance dd ?
    mov hInstance, FUNC(GetModuleHandle, NULL)

  ; -------------------------------------------
  ; Call the dialog box from the resource file
  ; -------------------------------------------
    invoke DialogBoxParam,hInstance,100,0,ADDR WndProc0,0

    invoke ExitProcess,eax

; 

WndProc0 proc hWin   :DWORD,
              uMsg   :DWORD,
              wParam :DWORD,
              lParam :DWORD

      STRING dlgTitle0,"Dialog Wizard Template"
      GLOBAL hWnd       dd ?

    ; -----------------------
    ; Dialog control handles
    ; -----------------------
      GLOBAL h0Group1   dd ?
      GLOBAL h0Radio1   dd ?
      GLOBAL h0Radio2   dd ?
      GLOBAL h0Radio3   dd ?
      GLOBAL h0Check1   dd ?
      GLOBAL h0Check2   dd ?
      GLOBAL h0Label1   dd ?
      GLOBAL h0Edit1    dd ?
      GLOBAL h0Combo1   dd ?
      GLOBAL lph0Combo1 dd ?     ; default address for subclass

      GLOBAL h0List1    dd ?
      GLOBAL lph0List1  dd ?     ; default address for subclass

      GLOBAL h0Butn1    dd ?
      GLOBAL h0Butn2    dd ?
      GLOBAL h0Butn3    dd ?

      .if uMsg == WM_INITDIALOG
        m2m hWnd, hWin    ; Copy hWin to GLOBAL variable
        invoke SendMessage,hWin,WM_SETTEXT,0,ADDR dlgTitle0
        invoke SendMessage,hWin,WM_SETICON,1,FUNC(LoadIcon,hInstance,1)

      ; --------------------------------
      ; Get the handle for each control
      ; --------------------------------
        mov h0Group1,   rv(GetDlgItem,hWin,101)
        mov h0Radio1,   rv(GetDlgItem,hWin,102)
        mov h0Radio2,   rv(GetDlgItem,hWin,103)
        mov h0Radio3,   rv(GetDlgItem,hWin,104)
        mov h0Check1,   rv(GetDlgItem,hWin,105)
        mov h0Check2,   rv(GetDlgItem,hWin,106)
        mov h0Label1,   rv(GetDlgItem,hWin,107)
        mov h0Edit1,    rv(GetDlgItem,hWin,108)
        mov h0Combo1,   rv(GetDlgItem,hWin,109)
        mov lph0Combo1, rv(SetWindowLong,h0Combo1,GWL_WNDPROC,sch0Combo1)

        mov h0List1,    rv(GetDlgItem,hWin,110)
        mov lph0List1,  rv(SetWindowLong,h0List1,GWL_WNDPROC,sch0List1)

        mov h0Butn1,    rv(GetDlgItem,hWin,111)
        mov h0Butn2,    rv(GetDlgItem,hWin,112)
        mov h0Butn3,    rv(GetDlgItem,hWin,113)

        xor eax, eax
        ret

      .elseif uMsg == WM_COMMAND
        .if wParam == 102 ; h0Radio1  RadioButton
          invoke MessageBox,hWin,SADD("Control handle = h0Radio1"),
                                 SADD("Control ID = 102"),MB_OK

        .elseif wParam == 103 ; h0Radio2  RadioButton
          invoke MessageBox,hWin,SADD("Control handle = h0Radio2"),
                                 SADD("Control ID = 103"),MB_OK

        .elseif wParam == 104 ; h0Radio3  RadioButton
          invoke MessageBox,hWin,SADD("Control handle = h0Radio3"),
                                 SADD("Control ID = 104"),MB_OK

        .elseif wParam == 105 ; h0Check1  CheckBox
          invoke MessageBox,hWin,SADD("Control handle = h0Check1"),
                                 SADD("Control ID = 105"),MB_OK

        .elseif wParam == 106 ; h0Check2  CheckBox
          invoke MessageBox,hWin,SADD("Control handle = h0Check2"),
                                 SADD("Control ID = 106"),MB_OK

        .elseif wParam == 111 ; h0Butn1   PushButton
          invoke MessageBox,hWin,SADD("Control handle = h0Butn1"),
                                 SADD("Control ID = 111"),MB_OK

        .elseif wParam == 112 ; h0Butn2   PushButton
          invoke MessageBox,hWin,SADD("Control handle = h0Butn2"),
                                 SADD("Control ID = 112"),MB_OK

        .elseif wParam == 113 ; h0Butn3   PushButton
          invoke MessageBox,hWin,SADD("Control handle = h0Butn3"),
                                 SADD("Control ID = 113"),MB_OK

        .endif

      .elseif uMsg == WM_PAINT
        invoke paint_proc0,hWin
        xor eax, eax
        ret

      .elseif uMsg == WM_CLOSE
        exit_dialog0:             ; jump to this label to close program
        invoke EndDialog,hWin,0

      .endif

    xor eax, eax    ; this must be here in NT4 and later
    ret

WndProc0 endp

; 

paint_proc0 proc hWin:DWORD

    LOCAL hDC:DWORD
    LOCAL Ps :PAINTSTRUCT

    mov hDC, rv(BeginPaint,hWin,ADDR Ps)
  ; --------------------------------------

  ; Write your graphics code here

  ; --------------------------------------
    invoke EndPaint,hWin,ADDR Ps

    ret

paint_proc0 endp

; 

sch0Combo1 proc \
       hCtl   :DWORD,
       uMsg   :DWORD,
       wParam :DWORD,
       lParam :DWORD

  ; ---------------------------------------------------------------------
  ; This subclass procedure processes the messages for combobox h0Combo1
  ; ---------------------------------------------------------------------
    .if uMsg == WM_COMMAND
      ; ---------------------------
      ; process LBN_ messages here
      ; ---------------------------

    .endif

    invoke CallWindowProc,lph0Combo1,hCtl,uMsg,wParam,lParam

    ret

sch0Combo1 endp

; 

sch0List1 proc \
       hCtl   :DWORD,
       uMsg   :DWORD,
       wParam :DWORD,
       lParam :DWORD

  ; --------------------------------------------------------------------
  ; This subclass procedure processes the messages for list box h0List1
  ; --------------------------------------------------------------------
    .if uMsg == WM_LBUTTONDBLCLK
      invoke MessageBox,hWnd,SADD("WM_LBUTTONDBLCLK sch0List1 here"),
                             SADD("Subclass for h0List1"),MB_OK

    .endif

    invoke CallWindowProc,lph0List1,hCtl,uMsg,wParam,lParam

    ret

sch0List1 endp

; 

end start

