@echo off
: -------------------------------
: if resources exist, build them
: -------------------------------
\MASM32\BIN\Rc.exe /v rsrc.rc
\MASM32\BIN\Cvtres.exe /machine:ix86 rsrc.res

if exist %1.obj del "Project.obj"
if exist %1.exe del "Project.exe"

: -----------------------------------------
: assemble Project.asm into an OBJ file
: -----------------------------------------
\MASM32\BIN\Ml.exe /c /coff "Project.asm"
if errorlevel 1 goto errasm

: --------------------------------------------------
: link the main OBJ file with the resource OBJ file
: --------------------------------------------------
\MASM32\BIN\Link.exe /SUBSYSTEM:WINDOWS "Project.obj" rsrc.obj
if errorlevel 1 goto errlink
dir "Project.*"
goto TheEnd

:errlink
: ----------------------------------------------------
: display message if there is an error during linking
: ----------------------------------------------------
echo.
echo There has been an error while linking this project.
echo.
goto TheEnd

:errasm
: -----------------------------------------------------
: display message if there is an error during assembly
: -----------------------------------------------------
echo.
echo There has been an error while assembling this project.
echo.
goto TheEnd

:TheEnd

pause
